%%Author: Pallavi A Raiturkar
%Name: correctEyeTrackingData
%Parameters: eyeTrackingData
%This function corrects the raw input eye tracking data, by removing any data points that are out of screen, or
%points where it was evident that the eye tracker wasn't collecting any valid data.
%%
function [eyeTrackingData]=correctEyeTrackingData(eyeTrackingData)
	
%    figure(2);
    
	%remove all data points where x coordinate is out of screen or eyeTracker was off
%     plot(eyeTrackingData.time(eyeTrackingData.x<=0),eyeTrackingData.pupil(eyeTrackingData.x<=0),'bx');
%     hold on;
	eyeTrackingData.y(eyeTrackingData.x<=0)=[];
	eyeTrackingData.time(eyeTrackingData.x<=0)=[];
    
	eyeTrackingData.pupil(eyeTrackingData.x<=0)=[];
	eyeTrackingData.x(eyeTrackingData.x<=0)=[];

	%remove all data points where y coordinate is out of screen or eyeTracker was off
    
%     plot(eyeTrackingData.time(eyeTrackingData.y<=0),eyeTrackingData.pupil(eyeTrackingData.y<=0),'bx');
%     hold on;
    
	eyeTrackingData.x(eyeTrackingData.y<=0)=[];
	eyeTrackingData.time(eyeTrackingData.y<=0)=[];
	eyeTrackingData.pupil(eyeTrackingData.y<=0)=[];
	eyeTrackingData.y(eyeTrackingData.y<=0)=[];

%     %remove all data points where x coordinate is out of screen or eyeTracker was off
% 	eyeTrackingData.y(eyeTrackingData.x<=0)=[];
% 	eyeTrackingData.time(eyeTrackingData.x<=0)=[];
% 	eyeTrackingData.pupil(eyeTrackingData.x<=0)=[];
% 	eyeTrackingData.x(eyeTrackingData.x<=0)=[];

% plot(eyeTrackingData.time(eyeTrackingData.x>1680),eyeTrackingData.pupil(eyeTrackingData.x>1680),'bx');
%     hold on;
% 	%remove all data points where y coordinate is out of screen or eyeTracker was off
% 	eyeTrackingData.x(eyeTrackingData.y<=0)=[];
% 	eyeTrackingData.time(eyeTrackingData.y<=0)=[];
% 	eyeTrackingData.pupil(eyeTrackingData.y<=0)=[];
% 	eyeTrackingData.y(eyeTrackingData.y<=0)=[];
    %remove all data points where x coordinate is out of screen or eyeTracker was off
	eyeTrackingData.y(eyeTrackingData.x>1680)=[];
	eyeTrackingData.time(eyeTrackingData.x>1680)=[];
	eyeTrackingData.pupil(eyeTrackingData.x>1680)=[];
	eyeTrackingData.x(eyeTrackingData.x>1680)=[];

%     plot(eyeTrackingData.time(eyeTrackingData.y>1050),eyeTrackingData.pupil(eyeTrackingData.y>1050),'bx');
%     hold on;
	%remove all data points where y coordinate is out of screen or eyeTracker was off
	eyeTrackingData.x(eyeTrackingData.y>1050)=[];
	eyeTrackingData.time(eyeTrackingData.y>1050)=[];
	eyeTrackingData.pupil(eyeTrackingData.y>1050)=[];
	eyeTrackingData.y(eyeTrackingData.y>1050)=[];
    
 
end