%%Author: Pallavi A Raiturkar
%Name: interpolatePupil
%Parameters: eyeTrackingData
%Returns: pupil
%%This function fills in the missing pupil diameters
function [output] = extrapolatePupil(pupil)

numberDataPoints = size(pupil,1);

a = 1:numberDataPoints;
b = 1:numberDataPoints;

zeropupil = pupil==0; % Zeros locations

pupil(zeropupil) = [];
a(zeropupil)=[];
output = interp1(a, pupil, b)';

stillZero = find(isnan(output));

if(size(stillZero,1)==1 && stillZero(1)==1) %first value is 0
    output(stillZero(1)) = output(stillZero(1)+1);
elseif(size(stillZero,1)==1 && stillZero(1)>=size(output,1))    %last value is 0
    output(stillZero(1)) = output(stillZero(1)-1);
elseif(size(stillZero,1)~=0)
    for i = 1: size(stillZero,1)
        if(stillZero(i) == 1 && stillZero(i+1)==2)
            output(stillZero(i)) = output(3);
        elseif(stillZero(i)==1)
            output(stillZero(i)) = 2*output(stillZero(i)+1) - output(stillZero(i)+2);
        elseif(stillZero(i)==2)
                output(stillZero(i)) = (output(stillZero(i)-1) + output(stillZero(i) +1))/2;
        else
        output(stillZero(i)) = output(stillZero(i) -1);
        end
    end
end

end