%%Author: Pallavi A Raiturkar
%Script to compute average plot of binned vectors, for raw, light response
%removed, and MA applied signals.
%simply change flag to 0 for raw, 1 for light response removed, and 2 for
%moving average. (3 can be added for low pass filtered PD)
%
clear;
clc;
vidChoice =1;
flag = 3; %0 for raw, 1 for light response removed, 2 for MA
vidName = returnVideoName(vidChoice);
[timeIndex,frameIndex] = returnFrameInfo(vidChoice);

subjectNumbers = [9 10 11 14 15 16 17 18];

if vidChoice == 7 | vidChoice == 9
    subjectNumbers = [9 10 11 14 16 17 18];
end
numSubjects = size(subjectNumbers,2);

numberFrames = returnNumberFrames(vidChoice);
if(vidChoice == 1)
    frameRate = 24;
else
    frameRate = 30;
end
numberSecondsRemoved = 12;
numberFramesRemoved = numberSecondsRemoved * frameRate;

newNumberFrames = numberFrames - numberFramesRemoved;
binValue = zeros(newNumberFrames,numSubjects);

[timeIndex, frameIndex] = removeFrameData(timeIndex, frameIndex, vidChoice, numberSecondsRemoved);

if flag == 0
    for i = 1:size(subjectNumbers,2)
        binValue(:,i) = returnBinValueRaw(vidChoice,subjectNumbers(i),numberSecondsRemoved);
    end
elseif flag == 1 
    for i = 1:size(subjectNumbers,2)
    binValue(:,i) = returnBinValueLR(vidChoice,subjectNumbers(i),numberSecondsRemoved);
    end
elseif flag ==2
    for i = 1:size(subjectNumbers,2)
    binValue(:,i) = returnBinValue(vidChoice,subjectNumbers(i),numberSecondsRemoved);
    end
elseif flag == 3
    for i = 1:size(subjectNumbers,2)
        binValue(:,i) = returnBinValueLRsmooth(vidChoice, subjectNumbers(i), numberSecondsRemoved);
    end
end

meanBinValue = mean(binValue,2);

figure(1);
hold on;
if(flag == 0)
plot(frameIndex(1112:1888),meanBinValue(1112:1888),'r','Linewidth',2);
elseif(flag == 1)
    plot(frameIndex(1112:1888),meanBinValue(1112:1888),'g','Linewidth',2);
elseif(flag == 2)
    plot(frameIndex,meanBinValue,'b','Linewidth',2);
elseif(flag == 3)
    plot(frameIndex, meanBinValue,'m','LineWidth',2);
end
hold on;
xL = get(gca,'xlim');
% plot(xL,[0.5 0.5],'k--','Linewidth',2);
xlabel('Frame Number');
% legend('Light Response Removed');

% highSelection = frameIndex(meanBinValue>=0.5);
% lowSelection = frameIndex(meanBinValue<0.5);
% 
% annotation = plotAnnotation(vidChoice,1);
% annotationNot = setdiff(frameIndex, annotation);
% 
% trueNegative = size(intersect(lowSelection,annotationNot),1)
% truePositive = size(intersect(highSelection,annotation),1)
% falseNegative = size(intersect(lowSelection,annotation),1)
% falsePositive = size(intersect(highSelection,annotationNot),1)
% 
% TG = size(annotation,1)
% TF = size(frameIndex,1)

if flag == 2
save(['C:\Projects\pupilDilation\Intermediate\' vidName '\Final\FinalVectors\frameIndexRaw.mat'],'frameIndex');
save(['C:\Projects\pupilDilation\Intermediate\' vidName '\Final\FinalVectors\meanBinValueRaw.mat'],'meanBinValue');
elseif flag == 3
save(['C:\Projects\pupilDilation\Intermediate\' vidName '\Final\FinalVectors\frameIndexLR.mat'],'frameIndex');
save(['C:\Projects\pupilDilation\Intermediate\' vidName '\Final\FinalVectors\meanBinValueLR.mat'],'meanBinValue');
end
