%%Author: Pallavi A Raiturkar
%Name: findAverageIntensityGaze
%%Author: Pallavi A Raiturkar
%%Script to plot normalized pupil diameters of subjects against luminosity
%%in 2 degrees visual angle around the gaze point
%%
function [avgIntensityGaze] = findAverageIntensityGaze(eyeTrackingData, frameNumber,vidName)

% vidChoice = 1;
% subjectNumber = 2;
% filepath = returnFilePathVideo(vidChoice,subjectNumber);
% [stimuliID,eyeTrackingData] = readEyeTrackingData(filepath);
% 
% eyeTrackingData = correctEyeTrackingData(eyeTrackingData);%remove points out of screen
% 
% frameNumber = returnFrameNumber(vidChoice, subjectNumber);

numberDataPoints = size(eyeTrackingData.pupil,1);
avgIntensityGaze = zeros(numberDataPoints,1);
i=1;
while i <=numberDataPoints
    I = imread(['C:\Projects\pupilDilation\Intermediate\' vidName '\EditedFrames\' num2str(frameNumber(i)) '.jpg']);
%     imshow(I);
%     hold on;
%     plot(eyeTrackingData.x(i),eyeTrackingData.y(i),'rx','MarkerSize',12,'LineWidth',3);
%     hold on;
%     rectangle('Position',[eyeTrackingData.x(i)-37,eyeTrackingData.y(i)-37,74,74],'EdgeColor','g','LineWidth',3);
    I = imcrop(I,[eyeTrackingData.x(i)-37,eyeTrackingData.y(i)-37,74,74]);
    I = double(rgb2gray(I));
    I = I/255;
    avgIntensity = mean(mean(I));
    avgIntensityGaze(i,:) = avgIntensity;
    i = i + 1
end

end


