%%Author: Pallavi A Raiturkar
%Name: findFrameNumber
%Parameters: vidChoice, eyeTrackingData, timeIndex, frameIndex
%Returns: frameNumber

function [frameNumber] = findFrameNumber(vidChoice,eyeTrackingData,timeIndex,frameIndex)


    [~, endTime] = returnTimes(vidChoice);

    numberDataPoints = size(eyeTrackingData.time,1);
    numberFrames = size(timeIndex,1);
    frameNumber = zeros(numberDataPoints,1);

    i=1;
    while i<=numberDataPoints
        j=1;
        while j<=numberFrames - 1
            if(timeIndex(j)<=(eyeTrackingData.time(i)*1.0e-6) & (eyeTrackingData.time(i)*1.0e-6)<=timeIndex(j+1))
                frameNumber(i,:)=frameIndex(j);
            end
            j=j+1;
        end
        i=i+1;
    end

    i=1;
    while i<=numberDataPoints
        if(timeIndex(numberFrames)<=(eyeTrackingData.time(i)*1.0e-6) & (eyeTrackingData.time(i)*1.0e-6)<=endTime)
            frameNumber(i,:)=frameIndex(numberFrames);
        end
        i=i+1;
    end

end