%%Author: Pallavi A Raiturkar
%Script to generate Figure 4 in SAP Paper
vidChoice = 3;
subjectNumber = 9;
filepath = returnFilePathVideo(vidChoice, subjectNumber);
[~,eyeTrackingData] = readEyeTrackingData(filepath);
eyeTrackingData = correctEyeTrackingData(eyeTrackingData);
eyeTrackingData = removeNoise(subjectNumber, eyeTrackingData);

avgIntensityGaze = returnAvgIntensityGaze(vidChoice, subjectNumber);

eyeTrackingData.pupil = (eyeTrackingData.pupil - min(eyeTrackingData.pupil))/(max(eyeTrackingData.pupil)-min(eyeTrackingData.pupil));

% figure(1);
% plot(eyeTrackingData.time(eyeTrackingData.time*1.0e-6<=10)*1.0e-6, eyeTrackingData.pupil(eyeTrackingData.time*1.0e-6<=10),'r','LineWidth',2);
% hold on;
% plot(eyeTrackingData.time(eyeTrackingData.time*1.0e-6<=10)*1.0e-6, avgIntensityGaze(eyeTrackingData.time*1.0e-6<=10),'g','LineWidth',2);
% plot(eyeTrackingData.time*1.0e-6,eyeTrackingData.pupil,'r');
% hold on;
% plot(eyeTrackingData.time*1.0e-6, avgIntensityGaze,'g');

fs = 120;
[b,a] = butter(5,1.25/(fs/2),'low');
lum_filtered = filtfilt(b,a,avgIntensityGaze);
figure(1);
plot(eyeTrackingData.time(eyeTrackingData.time*1.0e-6<=10)*1.0e-6, lum_filtered(eyeTrackingData.time*1.0e-6<=10),'g','LineWidth',2);
