%%Author: Pallavi A Raiturkar
%%Name: Script to generate step by step illustration figures for how the
%%Katti method was used to generate scores for one participant for the
%%video Decay.
%
vidChoice =1;
subjectNumber =9;
avgIntensityGaze = returnAvgIntensityGaze(vidChoice, subjectNumber);
[timeIndex, frameIndex] = returnFrameInfo(vidChoice);
if(vidChoice~=1)
    frameRate = 30;
else 
    frameRate = 24;
end

numberSecondsRemoved = 12;
numberFramesRemoved = frameRate*numberSecondsRemoved;

[eyeTrackingData,frameNumber,pupilFrame,pupilFrameLow] = returnData(vidChoice, subjectNumber);

fs = 120;
delay = returnDelay(vidChoice, subjectNumber);

[b3,a3] = butter(5,1.25/(fs/2),'low'); %to extract both emotional and luminosity component of PD     
lum_filtered = filtfilt(b3,a3,avgIntensityGaze);

numSamplesDelayed = round(fs*delay);

 [pBase,kLum] = returnModelParams(subjectNumber);
 predictedPD = [ ones(size(lum_filtered,1),1) lum_filtered ] * [pBase; kLum];
 predictedPD_delayed = [zeros(numSamplesDelayed,1);predictedPD(1:end-numSamplesDelayed)];
 
 pupil = eyeTrackingData.pupil - predictedPD_delayed;
 
 pupil = findAvgPupilPerFrame(pupil,frameIndex,frameNumber);
 pupil = extrapolatePupil(pupil);
 
 pupilFrame = pupil;
 
pupilFrame = pupilFrame(numberFramesRemoved+1:end);
[timeIndex, frameIndex] = removeFrameData(timeIndex, frameIndex, vidChoice, numberSecondsRemoved);

 
avgPupil = mean(pupilFrame);
stdPupil = std(pupilFrame);

dist = (pupilFrame - avgPupil)/stdPupil;
dist = smooth(dist,100);
fixed_dist = fix(dist);

figure(1);
hold on;
plot(frameIndex, fixed_dist,'m');
% plot(frameIndex, pupilFrame,'r');
% hold on;
% xL = get(gca,'xLim');
% plot(xL,[avgPupil avgPupil],'k-');