%%Author: Pallavi A Raiturkar
%Script to generate modified Katti results with light response removal
%See paper at C:\Projects\KattiPaper\Documentation
%
clear all;
clc;
vidChoice = 9;
subjectNumber =13;
color_i=1;

if(vidChoice~=1)
    frameRate = 30;
else 
    frameRate = 24;
end

color = hsv(10);

numberSecondsRemoved = 2;
numberFramesRemoved = frameRate*numberSecondsRemoved;

subjectNum = returnSubjectString(subjectNumber);
vidName = returnVideoName(vidChoice);

flag = 1; %this flag should be set to 0 for original Katti results, 1 for modified Katti results with no light response
smoothFlag = 0; %no MA filter if smoothFlag = 0, MA filter if smoothFlag = 1
% subtract1secFlag = 0; %don't subtract first second of data if subtract1secFlag = 0

if(flag == 0)
    
% %     filepath = returnFilePathVideo(vidChoice, subjectNumber);
    [timeIndex, frameIndex] = returnFrameInfo(vidChoice);
    [timeIndex, frameIndex] = removeFrameData(timeIndex, frameIndex, vidChoice, numberSecondsRemoved);
    [eyeTrackingData,frameNumber,pupilFrame,pupilFrameLow] = returnData(vidChoice, subjectNumber);
% %     [~,eyeTrackingData] = readEyeTrackingData(filepath);
% %     eyeTrackingData = correctEyeTrackingData(eyeTrackingData);
% %     eyeTrackingData = removeEyeTrackingData(eyeTrackingData,numberSecondsRemoved);
% %     eyeTrackingData = removeNoise(subjectNumber,eyeTrackingData,vidChoice);
% %     frameNumber = findFrameNumber(vidChoice,eyeTrackingData,timeIndex,frameIndex)
%     frameNumber = returnFrameNumber(vidChoice,subjectNumber);
%     frameNumber(frameNumber<=numberFramesRemoved) = [];
% %     if(size(eyeTrackingData.time,1)~=size(frameNumber,1))
% %         disp('Potential error');
% %     end
%     avgIntensityGaze = returnAvgIntensityGaze(vidChoice,subjectNumber);
% %     pupilFrame = findAvgPupilPerFrame(eyeTrackingData.pupil,frameIndex,frameNumber);
%     pupilFrame = returnPupilFrame(vidChoice, subjectNumber);
%     pupilFrame = pupilFrame(numberFramesRemoved+1:end);
% % %     pupil = extrapolatePupil(pupilFrame);
% %     pupilOrig = pupil;
    
%     if(subtract1secFlag == 1)
%     pupil = pupil(25:end);
%     end

    %apply smoothing filter of approx 4 seconds (according to paper)
    pupil = pupilFrame;
    
    if(smoothFlag == 1)
    smoothPupil = smooth(pupil,100);
    elseif(smoothFlag==0)
    smoothPupil = pupil;
    end
    
    %normalize to restrict pupil diameter between 0 and 1
    meanPupil = (smoothPupil- min(smoothPupil))/(max(smoothPupil)-min(smoothPupil));

    % mean of data
    % avgPupil = mean(meanPupil(15:end))
    avgPupil = mean(meanPupil);

    % std deviation of data
    % stdPupil = std(meanPupil(15:end))
    stdPupil = std(meanPupil);

    % %bin pupil diameter according to k*stdDev
    % 
    binValue = fix((meanPupil - avgPupil)/stdPupil);


    figure(1);
    plot(frameIndex,meanPupil,'g');
    hold on;
    plot(frameIndex,binValue,'b');
    xlabel('Frame Number');
    ylabel('Pupil Diameter(mm)');

%     save(['C:\Projects\pupilDilation\Intermediate\' vidName '\Final\s0' subjectNum '\meanPupil'],'meanPupil');
%    save(['C:\Projects\pupilDilation\Intermediate\' vidName '\Final\s0' subjectNum '\binValue_minus2sec'],'binValue');
    
elseif(flag == 1)
    
    [timeIndex, frameIndex] = returnFrameInfo(vidChoice);
    [timeIndex, frameIndex] = removeFrameData(timeIndex, frameIndex, vidChoice, numberSecondsRemoved);
    [eyeTrackingData,frameNumber,pupilFrame,pupilFrameLow] = returnData(vidChoice, subjectNumber);
    
% %     filepath = returnFilePathVideo(vidChoice, subjectNumber);
% %     [~,eyeTrackingData] = readEyeTrackingData(filepath);
% % %     eyeTrackingData = correctEyeTrackingData(eyeTrackingData);
% %     eyeTrackingData = removeNoise(subjectNumber,eyeTrackingData);
%     frameNumber = findFrameNumber(vidChoice, eyeTrackingData, timeIndex, frameIndex);
% %     size(eyeTrackingData.time)
% %     eyeTrackingData = removeEyeTrackingData(eyeTrackingData,numberSecondsRemoved);
    
    
% %     frameNumber = returnFrameNumber(vidChoice,subjectNumber);
% %     size(frameNumber)
% %     frameNumber(frameNumber<=numberFramesRemoved) = [];
%     avgIntensityGaze = returnAvgIntensityGaze(vidChoice,subjectNumber);
% %     [timeIndex, frameIndex] = returnFrameInfo(vidChoice);
% %     [timeIndex, frameIndex] = removeFrameData(timeIndex, frameIndex, vidChoice, numberSecondsRemoved);
    
% %     if(subjectNumber>=9)
% %         fs = 120;
% %     else
% %         fs = 60;
% %     end
% %     [b,a] = butter(5,0.06/(fs/2),'low'); %to extract only emotional component of PD
% %     pd_filtered_emo= filtfilt(b,a, eyeTrackingData.pupil); %only emotional (low pass of 0.33Hz)
    
    %Generate regression model and bandpass values to calculate relative
    %error metric
    
%     [pBase,kLum] = returnModelParams(subjectNumber); %get model parameters of subject
%     [b2,a2] = butter(5, [ 0.75/(fs/2) 1.25/(fs/2)],'bandpass'); %to extract only luminosity component of PD (band pass filter b/w 0.75Hz and 1.25Hz)
%     [b3,a3] = butter(5,1.25/(fs/2),'low'); %to extract both emotional and luminosity component of PD
%     
%     lum_filtered = filtfilt(b3,a3,avgIntensityGaze);
%     pd_filtered = filtfilt(b2,a2,eyeTrackingData.pupil);
%     pd_filtered_meanzero = pd_filtered - mean(pd_filtered(37:end));
%     predictedPD = [ ones(size(lum_filtered,1),1) lum_filtered ] * [pBase; kLum];
%     predictedPD_delayed = [zeros(36,1);predictedPD(1:end-36)]; %delay signal by 0.6 seconds (this includes pBase)
%     predictedPD_delayedMeanZero = predictedPD_delayed - mean(predictedPD_delayed(37:end));
%     
%     numberSamples = size(predictedPD_delayedMeanZero,1)-36;
%     pd_bandpass = pd_filtered_meanzero(37:end);
%     pd_regmodel = predictedPD_delayedMeanZero(37:end);
% 
% 
% e_per_sample = zeros(numberSamples,1);
% 
% figure(6);
% 
% plot(eyeTrackingData.time(37:end)*1.0e-6,pd_bandpass,'b');
% hold on;
% plot(eyeTrackingData.time(37:end)*1.0e-6,pd_regmodel,'m');
% e = abs(pd_bandpass - pd_regmodel);
% hold on;
% plot(eyeTrackingData.time(37:end)*1.0e-6,lum_filtered(37:end),'g');
% % plot(eyeTrackingData.time(37:end)*1.0e-6,e,'r');
% % hold on;
% for i = 1:numberSamples
% e_relative(i,:) = e(i)/abs(pd_bandpass(i));
% end
% hold on;
% % plot(eyeTrackingData.time(37:end)*1.0e-6,e_relative,'g');
% xlabel('Time(s)');
% legend('Band pass values(X)','Predicted values(Y)','Luminosity');
% 
% 
% %report final error as a percentage
% final_error = (mean(e_relative))*100
%     
    %%
% %     pupilFrame = findAvgPupilPerFrame(pd_filtered_emo,frameIndex,frameNumber);
% %     pupil = extrapolatePupil(pupilFrame);

%     pupilOrig = pupil; %save a copy
    
%     if(subtract1secFlag == 1)
%     pupil = pupil(25:end);
%     end

%     pupil = pupil(numberFramesRemoved+1:end);
%     frameIndex = frameIndex(numberFramesRemoved+1:end);
    
    %apply smoothing filter of approx 4 seconds (according to paper)
    
    pupil = pupilFrameLow;
    if(smoothFlag == 1)
    smoothPupil = smooth(pupil,100);
    elseif(smoothFlag==0)
    smoothPupil = pupil;
    end
    
    %normalise to restrict pupil diameter between 0 and 1
    meanPupil = (smoothPupil- min(smoothPupil))/(max(smoothPupil)-min(smoothPupil));

    % mean of data
    % avgPupil = mean(meanPupil(15:end))
    avgPupil = mean(meanPupil);

    % std deviation of data
    % stdPupil = std(meanPupil(15:end))
    stdPupil = std(meanPupil);

    % %bin pupil diameter according to k*stdDev
    % 
    binValue = fix((meanPupil - avgPupil)/stdPupil);

    figure(1);
    plot(frameIndex,meanPupil,'g');
    hold on;
    plot(frameIndex,binValue,'b');
    xlabel('Frame Number');
    ylabel('Pupil Diameter(mm)');

%     save(['C:\Projects\pupilDilation\Intermediate\' vidName '\Final\s0' subjectNum '\meanPupilLum'],'meanPupil');
%   save(['C:\Projects\pupilDilation\Intermediate\' vidName '\Final\s0' subjectNum '\binValueLum_minus2sec_nosmooth'],'binValue');
end