%%Author: Pallavi A Raiturkar
%Script to render out plot animations for supplementary movie (SAP 2016)
%%
clear;
clc;
vidChoice = 1;
vidName = returnVideoName(vidChoice);
frameIndexRaw = load(['C:\Projects\pupilDilation\Intermediate\' vidName '\Final\FinalVectors\frameIndexRaw']);
binValueRaw = load(['C:\Projects\pupilDilation\Intermediate\' vidName '\Final\FinalVectors\meanBinValueRaw']);
frameIndexLR = load(['C:\Projects\pupilDilation\Intermediate\' vidName '\Final\FinalVectors\frameIndexLR']);
binValueLR = load(['C:\Projects\pupilDilation\Intermediate\' vidName '\Final\FinalVectors\meanBinValueLR']);

frameIndexRaw = frameIndexRaw.frameIndex;
frameIndexLR = frameIndexLR.frameIndex;
binValueRaw = binValueRaw.meanBinValue;
binValueLR = binValueLR.meanBinValue;

numberFrames = returnNumberFrames(vidChoice);
if(vidChoice == 1)
    frameRate = 24;
else
    frameRate = 30;
end
numberSecondsRemoved = 12;
numberFramesRemoved = numberSecondsRemoved * frameRate;

v = VideoWriter('decay1.mp4','MPEG-4');
v.FrameRate = frameRate;
open(v)
firstFrame = numberFramesRemoved + 1;
lastFrame = frameIndexRaw(end);

h = figure(1);
set(h, 'Position',[100 100 1500 500]);
set(h,'defaultfigurecolor',[1 1 1]);re
hold on;

for i = firstFrame:lastFrame
    clf;
    plot(frameIndexRaw,binValueRaw,'LineWidth',2,'Color','b');
    hold on;
    plot(frameIndexLR, binValueLR,'LineWidth',2,'Color','m');
    xlabel('Frame Number');
    ylabel('Score');
    axis('tight')
    xlim([firstFrame lastFrame]);
    ylim([-1.5 1.5]);
    hold on;
    plotAnnotation(vidChoice,1);
    hold on;
    plotAnnotation(vidChoice,2);
    hold on;
    xlim([firstFrame lastFrame]);
    xlim('manual');
    ylim([-1.5 1.5])
    yL = get(gca,'yLim');
    xL = get(gca,'xLim');
    set(gca,'TickLength',[0 0]);
    hold on;
    plot(xL,[0 0],'k--','LineWidth',1);
    hold on;
    plot([i i],yL,'k','LineWidth',2);
    ax = gca;
    ax.Units = 'pixels';
    pos = ax.Position;
    marg = 30;
    rect = [-marg, -marg, pos(3)+2*marg, pos(4)+2*marg];
    frame = getframe(gca,rect);
    writeVideo(v,frame);
end

close(v)
