%%Author: Pallavi A Raiturkar
%Name: interpolatePupil
%Parameters: pupil (raw pupil diameter data)
%Returns: pupil_interpolated (interpolated pupil diameter)
%%This function fills in the missing pupil diameters
%%(eyeTrackingData.pupil=0)
function [pupil_interpolated] = interpolatePupil(pupil)

numberDataPoints = size(pupil,1);

a = 1:numberDataPoints;
b = 1:numberDataPoints;

zeropupil = pupil==0; % Zeros locations

pupil(zeropupil) = [];
a(zeropupil)=[];
pupil_interpolated = interp1(a, pupil, b)';

% figure(3);
% plot(pupil_interpolated,'b');
stillZero = find(isnan(pupil_interpolated));

if(size(stillZero,1)~=0)
    for i = 1: size(stillZero,1)
        for j = (stillZero(i)+1):size(pupil_interpolated,1)
            if(pupil_interpolated(j)~=0 && ~isnan(pupil_interpolated(j)))
                pupil_interpolated(stillZero(i)) = pupil_interpolated(j);
                break;
            end
        end
    end
end

stillZero = find(isnan(pupil_interpolated));

if(size(stillZero,1)~=0)
    for i = 1: size(stillZero,1)
        for j = (stillZero(i)-1):-1:1
            if(pupil_interpolated(j)~=0 && ~isnan(pupil_interpolated(j)))
                pupil_interpolated(stillZero(i)) = pupil_interpolated(j);
                break;
            end
        end
    end
end

% hold on;
% plot(pupil_interpolated,'g');

end