%%Author: Pallavi A Raiturkar
%Name: plotAnnotations
%Parameters: vidChoice,rank (1 (more engaging) or 2 (less engaging))
%Plots the annotations from 3 different coders for short videos
function [annotation]= plotAnnotation(vidChoice,rank)

% vidChoice = 9;
videoID = [ones(1,6)*1 ones(1,6)*3 ones(1,6)*4 ones(1,6)*5 ones(1,6)*6 ones(1,6)*7 ones(1,6)*9];
coderID = [1 1 2 2 3 3 1 1 2 2 3 3 1 1 2 2 3 3 1 1 2 2 3 3 1 1 2 2 3 3 1 1 2 2 3 3 1 1 2 2 3 3];
ranks =     [1 2 1 1 1 2 1 2 1 1 1 2 1 2 1 2 1 2 1 2 2 1 1 2 1 2 1 2 1 2 1 2 1 1 1 2 1 2 2 1 1 2];
startFrame = [1700 600 525 1716 789 1717 1600 600 357 388 390 1589 400 1000 402 327 332 423 700 100 0 718 724 481 800 300 836 368 374 854 750 400 755 378 775 394 0 1250 2232 1338 1246 183];
endFrame =[2000 900 802 2079 869 2045 2500 1000 397 440 849 2123 700 1200 478 388 410 448 900 200 139 792 821 683 1000 700 1076 495 453 1084 1000 750 813 726 952 513 400 1400 2525 2202 1300 204];
annotations = struct('videoID',videoID,'coderID',coderID,'rank',ranks,'start',startFrame,'end',endFrame);

% hold on;
% yL= get(gca,'yLim');
% y = yL(1);
% h = yL(2);
% figure(1);
% xlim([0 2000]);
% ylim([0 2000]);
yL = get(gca,'yLim');
yL_low = yL(1);
yL_high = yL(2);
annotation1 =[];
annotation2 =[];
annotation3 = [];
for i = 1:size(videoID,2)
    if(videoID(i)==vidChoice)
        if(coderID(i) == 1)
            if(ranks(i)==1&& ranks(i)==rank)
                p = patch([startFrame(i), endFrame(i), endFrame(i),startFrame(i)],[yL_low,yL_low,yL_high,yL_high],'r');
                set(p,'FaceAlpha',0.1,'LineStyle','none');
                hold on;
                annotation1 = [startFrame(i):endFrame(i)];
            elseif(ranks(i)==2&& ranks(i)==rank)
                p = patch([startFrame(i), endFrame(i), endFrame(i),startFrame(i)],[yL_low,yL_low,yL_high,yL_high],'b');
                set(p,'FaceAlpha',0.1,'LineStyle','none');
                hold on;  
                annotation1 = [startFrame(i):endFrame(i)];
            end
        elseif(coderID(i) == 2)
            if(ranks(i)==1&& ranks(i)==rank)
                p = patch([startFrame(i), endFrame(i), endFrame(i),startFrame(i)],[yL_low,yL_low,yL_high,yL_high],'r');
                set(p,'FaceAlpha',0.1,'LineStyle','none');
                hold on;
                annotation2 = [startFrame(i):endFrame(i)];
            elseif(ranks(i)==2&& ranks(i)==rank)
                p = patch([startFrame(i), endFrame(i), endFrame(i),startFrame(i)],[yL_low,yL_low,yL_high,yL_high],'b');
                set(p,'FaceAlpha',0.1,'LineStyle','none');
                hold on;  
                annotation2 = [startFrame(i):endFrame(i)];
            end
        elseif(coderID(i)==3)
            if(ranks(i)==1&& ranks(i)==rank)
                p = patch([startFrame(i), endFrame(i), endFrame(i),startFrame(i)],[yL_low,yL_low,yL_high,yL_high],'r');
                set(p,'FaceAlpha',0.1,'LineStyle','none');
                hold on;
                annotation3 = [startFrame(i):endFrame(i)];
            elseif(ranks(i)==2 && ranks(i)==rank)
                p = patch([startFrame(i), endFrame(i), endFrame(i),startFrame(i)],[yL_low,yL_low,yL_high,yL_high],'b');
                set(p,'FaceAlpha',0.1,'LineStyle','none');
                hold on;  
                annotation3 = [startFrame(i):endFrame(i)];
            end
        end
            
    end
end

annotation = [union(union(annotation1, annotation2),annotation3)]';
end