%%Author: Pallavi A Raiturkar
%Script to view data against average intensity
%For December and January subjects only (experiment was conducted
%differently for September subjects)
clear;
clc;
vidChoice = 7;
switch(vidChoice)
    case 1 
        subjectNumbers = [2 3 5 6 7 8 9 10 11 12 13];
    case 3
        subjectNumbers = [2 3 5 6 8 9 10 11 13];
    case 4
        subjectNumbers = [2 3 5 6 7 8 9 10 11 12 13];
    case 5
        subjectNumbers = [2 3 5 6 7 8 9 10 11 12 13];
    case 6
        subjectNumbers = [2 5 6 7 8 9 10 11 12 13];
    case 7
        subjectNumbers = [2 3 5 6 7 8 9 10 11 13];
    case 9
        subjectNumbers = [9 10 11 12 13];
end
numSubjects = size(subjectNumbers,2);
color = hsv(12);
for i = 1:numSubjects
subjectNumber = subjectNumbers(i);
%video
avgIntensityGaze = returnAvgIntensityGaze(vidChoice, subjectNumber);
filepath = returnFilePathVideo(vidChoice, subjectNumber);
[~,eyeTrackingData] = readEyeTrackingData(filepath);
eyeTrackingData = correctEyeTrackingData(eyeTrackingData);
eyeTrackingData = removeNoise(subjectNumber, eyeTrackingData);
% eyeTrackingData.pupil = eyeTrackingData.pupil - mean(eyeTrackingData.pupil);

%fixation cross before video
% avgIntensityGazeFix = returnAvgIntensityGazeFix(vidChoice, subjectNumber);
% filepathFix = returnFilePathFixCross(vidChoice, subjectNumber);
% [~,eyeTrackingDataFix] = readEyeTrackingData(filepathFix);
% eyeTrackingDataFix = correctEyeTrackingData(eyeTrackingDataFix);
% eyeTrackingDataFix = removeNoise(subjectNumber, eyeTrackingDataFix);
% eyeTrackingDataFix.pupil = eyeTrackingDataFix.pupil - mean(eyeTrackingDataFix.pupil);

% avgIntensity_total = [avgIntensityGazeFix; avgIntensityGaze];
% pupil_total = [eyeTrackingDataFix.pupil;eyeTrackingData.pupil];
% time = [eyeTrackingDataFix.time; eyeTrackingDataFix.time(end)+eyeTrackingData.time];

% pupil = eyeTrackingData.pupil(eyeTrackingData.time*1.0e-6>=2);
% time = eyeTrackingData.time(eyeTrackingData.time*1.0e-6>=2);
% avgIntensityGaze = avgIntensityGaze(eyeTrackingData.time*1.0e-6>=2);
% time = time*1.0e-6;
pupil = (eyeTrackingData.pupil - min(eyeTrackingData.pupil))/(max(eyeTrackingData.pupil)-min(eyeTrackingData.pupil));
% pupil = pupil - mean(pupil);
% pupil_total = (pupil_total - min(pupil_total))/(max(pupil_total)-min(pupil_total));

figure(2);
plot(eyeTrackingData.time*1.0e-6,avgIntensityGaze,'Color',color(i,:));
% hold on;
% plot(eyeTrackingData.time*1.0e-6,pupil,'Color',color(i,:));
% hold on;
% plot(time(time*1.0e-6<=12)*1.0e-6,pupil_total(time*1.0e-6<=12),'Color',color(i,:));
% BreakXAxis(time(time<=75),pupil(time<=75),12,65,5,color(i,:));
% hold on;
% plot(time(time*1.0e-6<=12)*1.0e-6,pupil(time*1.0e-6<=12),'Color',color(i,:));
% % hold on;
% plot(time(time*1.0e-6>=2& time*1.0e-6<=12)*1.0e-6,pupil(time*1.0e-6>=2 & time*1.0e-6<=12),'Color',color(i,:));
% plot(time*1.0e-6,pupil,'Color',color(i,:));
% plot(time*1.0e-6,pupil,'Color',color(i,:));

hold on;

% yL = get(gca,'yLim');
% xL = [eyeTrackingDataFix.time(end)*1.0e-6 eyeTrackingDataFix.time(end)*1.0e-6];
% plot(xL,yL,'k-.');
% hold on;
% legend('Average Intensity','Pupil Diameter');
xlabel('Time(s)');
ylabel('Normalized Pupil Diameter');
end
figure(2),set(gca,'box','off');
