%Author: Pallavi A Raiturkar
%Script to generate plot for SAP paper (grayscale intensity v/s lux values)
intensity = [0 64 128 192 255];
lux_values_sept = [0 3.5 10 20 40];
lux_values_dec = [3.5 5 7 14 28];
lux_values_feb1 = [2.5 4 7 14 28];
lux_values_feb2 = [3.5 5 7 14 28];
lux_values_feb3 = [2.5 4 7 14 30];


figure;
plot(intensity,lux_values_sept,'rx');
hold on;
plot(intensity, lux_values_dec,'bx');
hold on;
plot(intensity,lux_values_feb1,'gx');
hold on;
plot(intensity,lux_values_feb2,'m+');
hold on;
plot(intensity,lux_values_feb3,'cx');
legend('Session 1','Session 2','Session 3','Session 4','Session 5');
xlabel('Grayscale intensity (0-255) of calibration slides');
ylabel('Light Intensity (lumens)');
title('Measured lumens at participant head position');
xlim([0 260]);
set(gca,'FontSize',16);
axis('tight');
