%%Author: Pallavi A Raiturkar
%Script to learn regression model values pBase and kLum for any subject
%
% subjectNumber = 18;
% filepath = returnFilePathImage(subjectNumber);
% [~,eyeTrackingData] = readEyeTrackingData(filepath);

% figure(1);
% plot(eyeTrackingData.time*1.0e-6, eyeTrackingData.pupil);

%Linear regression for equation form p = p_0 + (k * luminosity) where p is
%the pupil diameter, p_0 is the base pupil diameter, k is a constant factor
%and luminosity is the frame luminosity

lum = [64;128;192;255]/255;

p = zeros(4,14);
p(:,1)= [3.19; 2.93; 2.91; 2.77]; %s002
p(:,2) =[3.72; 3.42; 2.9; 2.73]; %s003
p(:,3) =[5.74; 4.91; 4.67; 3.67]; %s005
p(:,4) =[3.3; 2.79; 2.53; 2.39]; %s006
p(:,5) =[3.8; 3.47; 3.31; 2.86]; %s007
p(:,6) =[3.96; 3.66; 3.33; 3.2]; %s008
p(:,7) =[3.555; 3.08; 2.785; 2.645]; %s009
p(:,8) =[4.092; 3.805; 4.347; 3.351]; %s010
p(:,9) =[5.069; 4.327; 4.1; 3.686]; %s011
p(:,10) = [4.76;4.266;4.032;3.561]; %s014
p(:,11)=[4.659;3.718;3.499;3.561]; %s015
p(:,12)=[5.309;4.947;3.605;3.275];%s016
p(:,13)=[5.73;4.955;4.669;4.456]; %s017
p(:,14)=[4.385;3.916;3.422;3.299]; %s018

p_k=zeros(2,14);
for i = 1:14
lum_appended = [ones(size(lum,1),1) , lum];
[p_k(:,i)] = lum_appended\p(:,i);
end


% figure;
% plot( eyeTrackingData.time*1.0e-6 ,eyeTrackingData.pupil,'r');
% hold on;
% refline(p_k(2,1),p_k(1,1));
% ylim([0 6]);
% ylim('manual');
% xlabel('Time in seconds');
% ylabel('Pupil Diameter');

figure;
plot(lum,p(:,1),'bo');
hold on;
refline(p_k(2,1),p_k(1,1));

p_k