%Author: Pallavi A Raiturkar
%Name: returnOrderVideo
%Parameters: subjectNumber
%Returns: videoNumbers
%This function takes in the subject number(ID) as parameter, and returns
%the order in which videos were shown to that particular subject. The order
%is a vector with the video numbers, in that order.
%NOTE: 
%vid1: 017_decayfix1
%vid2: 998_fixationvid
%vid3: bearattack
%vid4: goprosurprise
%vid5: lion
%vid6: rhinocharges
%vid7: volcanoeruption
%vid8: znewfixationvid
%vid9: kidbreakglass

function [videoNumbers] = returnOrderVideo(subjectNumber)

switch(subjectNumber)
    case 2
        videoNumbers = [2,3,1,4,8,5,7,6];
    case 3
        videoNumbers = [3,4,2,5,1,6,8,7];
    case 5
        videoNumbers = [5,6,4,7,3,8,2,1];
    case 6
        videoNumbers = [6,7,5,8,4,1,3,2];
    case 7
        videoNumbers = [7,8,6,1,5,2,4,3];
    case 8
        videoNumbers = [8,1,7,2,6,3,5,4];
    case 9
        videoNumbers = [1,9,6,8,5,7,2,3,4];
    case 10
        videoNumbers = [5,6,4,1,3,8,9,7,2];
    case 11
        videoNumbers = [7,6,4,2,8,5,9,3,1];
    case 12
        videoNumbers = [1,7,3,9,2,6,4,8,5];
    case 13
        videoNumbers = [5,9,4,1,7,3,8,2,6];
    case 14
        videoNumbers = [1,9,2,7,4,3,8,6,5];
    case 15
        videoNumbers = [8,2,9,7,1,4,3,6,5];
    case 16
        videoNumbers = [2,3,1];
    case 17
        videoNumbers = [1,2,6,9,8,3,5,4,7];
end